#ifndef __ZYXEL_H
#define __ZYXEL_H


typedef struct
{
	unsigned char	title [5] ;
	unsigned char	mode ;
	unsigned char	res_0_ [4] ;
	unsigned char	voice ;						// needed for endian independence
	unsigned char	voice_not_needed_yet ;		// unsigned short voice ;
	unsigned char	res_1_ [4] ;
} ZyxelHeader ;


typedef struct
{
	ZyxelHeader		zyxel ;
	char			*voice ;
	int				voicelen ;
	char			*play ;
	int				playlen ;
} ZyxelSND ;


#define	ZYX_TITLE			"ZyXEL"
#define	ZYX_NOZYXELSTRUCT	-2

/* mode values in ZyxelHeader */
#define ZYX_VOC				2
#define	ZYX_NOMODE			-3

/* voice values in ZyxelHeader */
#define ZYX_AD3				2
#define ZYX_AD2				1
#define	ZYX_CLP 			0
#define	ZYX_NOVOICE			-4

/* voice compression mode */
#define VSM(vc)				(vc+1)

/* bytes per second for receiving voice */
#define VBPS(vc)			(vc == ZYX_AD3 ? 3600 : (vc == ZYX_AD2 ? 2400 :\
							(vc == ZYX_CLP ? 1200 : 0)))


int ZSNDread (char *filename,ZyxelSND *zsnd) ;
int ZSNDmakePlayable (ZyxelSND *zsnd) ;
void ZSNDfree (ZyxelSND *zsnd) ;

#endif